#!/bin/bash
#
#
# у нас стенд - можновсе

SSH="ssh -o StrictHostKeyChecking=no" 

# Все КД кроме самого себя
dc=$(samba-tool ou listobjects 'OU=Domain Controllers' | grep -oP 'CN=\w+' |  awk -F '=' '{print tolower($2)}' | grep -v $(hostname -s))

# Если никаких КД более нет
if [[ -z $dc ]]; then 
	exit 0
fi

# приводим sysvol в порядок
if ! samba-tool ntacl sysvolcheck; then samba-tool ntacl sysvolreset; fi

rm -f /var/lib/samba/private/idmap.ldb.bak  >/dev/null 2>&1
/usr/bin/tdbbackup -s .bak /var/lib/samba/private/idmap.ldb  >/dev/null 2>&1

for i in ${dc}; do 
#idmap
/usr/bin/rsync -e "${SSH}" -avz /var/lib/samba/private/idmap.ldb.bak ${i}:/var/lib/samba/private/idmap.ldb  >/dev/null 2>&1

#sysvol
/usr/bin/rsync -e "${SSH}"  -XAavz /var/lib/samba/sysvol/ ${i}:///var/lib/samba/sysvol/ >/dev/null 2>&1

${SSH} root@${i} 'net cache flush; if ! samba-tool ntacl sysvolcheck; then samba-tool ntacl sysvolreset; fi'
done
